/*
 * example_mutex.c
 */
#include <linux/module.h>
#include <linux/mutex.h>
#include <linux/printk.h>

static DEFINE_MUTEX(mymutex);

static int __init example_mutex_init(void)
{
    int ret;

    pr_info("example_mutex 初始化\n");

    ret = mutex_trylock(&mymutex);
    if (ret != 0) {
        pr_info("已锁定\n");

        if (mutex_is_locked(&mymutex) == 0)
            pr_info("锁定失败!\n");

        mutex_unlock(&mymutex);
        pr_info("已解锁\n");
    } else
        pr_info("锁定失败\n");

    return 0;
}

static void __exit example_mutex_exit(void)
{
    pr_info("example_mutex 卸载\n");
}

module_init(example_mutex_init);
module_exit(example_mutex_exit);

MODULE_DESCRIPTION("互斥锁示例");
MODULE_LICENSE("GPL");
